package pogr;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;
import javax.imageio.ImageIO;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.JScrollPane;

/**
 *
 * @author KarelSimanek
 */
public class Window extends javax.swing.JFrame {

    /**
     * Creates new form Window
     */
    public Window() {
        initComponents();
    }
    
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jFileChooser1 = new javax.swing.JFileChooser();
        jToolBar1 = new javax.swing.JToolBar();
        jButton2 = new javax.swing.JButton();
        jButton7 = new javax.swing.JButton();
        jLabel1 = new javax.swing.JLabel();
        jButton1 = new javax.swing.JButton();
        jButton4 = new javax.swing.JButton();
        jLabel2 = new javax.swing.JLabel();
        jButton3 = new javax.swing.JButton();
        jButton5 = new javax.swing.JButton();
        jLabel3 = new javax.swing.JLabel();
        jButton6 = new javax.swing.JButton();
        jButton8 = new javax.swing.JButton();
        jMenuBar1 = new javax.swing.JMenuBar();
        jMenu1 = new javax.swing.JMenu();
        jMenuItem1 = new javax.swing.JMenuItem();
        jMenuItem2 = new javax.swing.JMenuItem();
        jSeparator1 = new javax.swing.JPopupMenu.Separator();
        jMenuItem3 = new javax.swing.JMenuItem();
        jMenu2 = new javax.swing.JMenu();
        jMenuItem4 = new javax.swing.JMenuItem();
        jMenuItem8 = new javax.swing.JMenuItem();
        jMenuItem16 = new javax.swing.JMenuItem();
        jMenuItem5 = new javax.swing.JMenuItem();
        jMenuItem6 = new javax.swing.JMenuItem();
        jMenu3 = new javax.swing.JMenu();
        jMenuItem15 = new javax.swing.JMenuItem();

        setTitle("Dithering by Karel Šimánek");
        setPreferredSize(new java.awt.Dimension(800, 800));
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                formWindowClosing(evt);
            }
        });

        jToolBar1.setBackground(new java.awt.Color(255, 255, 255));
        jToolBar1.setFloatable(false);
        jToolBar1.setRollover(true);

        jButton2.setIcon(new javax.swing.ImageIcon(getClass().getResource("/pogr/Ikony/save.jpg"))); // NOI18N
        jButton2.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jButton2.setFocusable(false);
        jButton2.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButton2.setRolloverIcon(new javax.swing.ImageIcon(getClass().getResource("/pogr/Ikony/save_pressed.jpg"))); // NOI18N
        jButton2.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton2ActionPerformed(evt);
            }
        });
        jToolBar1.add(jButton2);

        jButton7.setIcon(new javax.swing.ImageIcon(getClass().getResource("/pogr/Ikony/free-icon-design-set-open.jpg"))); // NOI18N
        jButton7.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jButton7.setFocusable(false);
        jButton7.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButton7.setRolloverIcon(new javax.swing.ImageIcon(getClass().getResource("/pogr/Ikony/free-icon-design-set-open_pressed.jpg"))); // NOI18N
        jButton7.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jButton7.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton7ActionPerformed(evt);
            }
        });
        jToolBar1.add(jButton7);

        jLabel1.setMaximumSize(new java.awt.Dimension(20, 0));
        jLabel1.setMinimumSize(new java.awt.Dimension(20, 0));
        jToolBar1.add(jLabel1);

        jButton1.setIcon(new javax.swing.ImageIcon(getClass().getResource("/pogr/Ikony/left.jpg"))); // NOI18N
        jButton1.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jButton1.setFocusable(false);
        jButton1.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButton1.setRolloverIcon(new javax.swing.ImageIcon(getClass().getResource("/pogr/Ikony/left_pressed.jpg"))); // NOI18N
        jButton1.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });
        jToolBar1.add(jButton1);

        jButton4.setIcon(new javax.swing.ImageIcon(getClass().getResource("/pogr/Ikony/right.jpg"))); // NOI18N
        jButton4.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jButton4.setFocusable(false);
        jButton4.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButton4.setRolloverIcon(new javax.swing.ImageIcon(getClass().getResource("/pogr/Ikony/right_pressed.jpg"))); // NOI18N
        jButton4.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jButton4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton4ActionPerformed(evt);
            }
        });
        jToolBar1.add(jButton4);

        jLabel2.setMaximumSize(new java.awt.Dimension(20, 0));
        jLabel2.setMinimumSize(new java.awt.Dimension(20, 0));
        jToolBar1.add(jLabel2);

        jButton3.setIcon(new javax.swing.ImageIcon(getClass().getResource("/pogr/Ikony/zoomIn.jpg"))); // NOI18N
        jButton3.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jButton3.setFocusable(false);
        jButton3.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButton3.setRolloverIcon(new javax.swing.ImageIcon(getClass().getResource("/pogr/Ikony/zoomIn_pressed.jpg"))); // NOI18N
        jButton3.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jButton3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton3ActionPerformed(evt);
            }
        });
        jToolBar1.add(jButton3);

        jButton5.setIcon(new javax.swing.ImageIcon(getClass().getResource("/pogr/Ikony/zoomOut.jpg"))); // NOI18N
        jButton5.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jButton5.setFocusable(false);
        jButton5.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButton5.setRolloverIcon(new javax.swing.ImageIcon(getClass().getResource("/pogr/Ikony/zoomOut_pressed.jpg"))); // NOI18N
        jButton5.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jButton5.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton5ActionPerformed(evt);
            }
        });
        jToolBar1.add(jButton5);

        jLabel3.setMaximumSize(new java.awt.Dimension(20, 0));
        jLabel3.setMinimumSize(new java.awt.Dimension(20, 0));
        jToolBar1.add(jLabel3);

        jButton6.setIcon(new javax.swing.ImageIcon(getClass().getResource("/pogr/Ikony/arrows_back.jpg"))); // NOI18N
        jButton6.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jButton6.setFocusable(false);
        jButton6.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButton6.setMaximumSize(new java.awt.Dimension(27, 23));
        jButton6.setMinimumSize(new java.awt.Dimension(27, 23));
        jButton6.setRolloverIcon(new javax.swing.ImageIcon(getClass().getResource("/pogr/Ikony/arrows_back_pressed.jpg"))); // NOI18N
        jButton6.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jButton6.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton6ActionPerformed(evt);
            }
        });
        jToolBar1.add(jButton6);

        jButton8.setIcon(new javax.swing.ImageIcon(getClass().getResource("/pogr/Ikony/arrows_forward.jpg"))); // NOI18N
        jButton8.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jButton8.setFocusable(false);
        jButton8.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButton8.setMaximumSize(new java.awt.Dimension(27, 23));
        jButton8.setMinimumSize(new java.awt.Dimension(27, 23));
        jButton8.setRolloverIcon(new javax.swing.ImageIcon(getClass().getResource("/pogr/Ikony/arrows_forward_pressed.jpg"))); // NOI18N
        jButton8.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jButton8.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton8ActionPerformed(evt);
            }
        });
        jToolBar1.add(jButton8);

        getContentPane().add(jToolBar1, java.awt.BorderLayout.PAGE_START);

        jMenu1.setText("File");

        jMenuItem1.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_O, java.awt.event.InputEvent.CTRL_MASK));
        jMenuItem1.setText("Load");
        jMenuItem1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem1ActionPerformed(evt);
            }
        });
        jMenu1.add(jMenuItem1);

        jMenuItem2.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_S, java.awt.event.InputEvent.CTRL_MASK));
        jMenuItem2.setText("Save");
        jMenuItem2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem2ActionPerformed(evt);
            }
        });
        jMenu1.add(jMenuItem2);
        jMenu1.add(jSeparator1);

        jMenuItem3.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_C, java.awt.event.InputEvent.CTRL_MASK));
        jMenuItem3.setText("Exit");
        jMenuItem3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem3ActionPerformed(evt);
            }
        });
        jMenu1.add(jMenuItem3);

        jMenuBar1.add(jMenu1);

        jMenu2.setText("Edit");

        jMenuItem4.setText("Make GrayScale");
        jMenuItem4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem4ActionPerformed(evt);
            }
        });
        jMenu2.add(jMenuItem4);

        jMenuItem8.setText("Tresholding");
        jMenuItem8.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem8ActionPerformed(evt);
            }
        });
        jMenu2.add(jMenuItem8);

        jMenuItem16.setText("Dithering");
        jMenuItem16.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem16ActionPerformed(evt);
            }
        });
        jMenu2.add(jMenuItem16);

        jMenuItem5.setText("Asciify");
        jMenuItem5.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem5ActionPerformed(evt);
            }
        });
        jMenu2.add(jMenuItem5);

        jMenuItem6.setText("Highlight Edges");
        jMenuItem6.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem6ActionPerformed(evt);
            }
        });
        jMenu2.add(jMenuItem6);

        jMenuBar1.add(jMenu2);

        jMenu3.setText("Help");

        jMenuItem15.setText("About");
        jMenuItem15.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem15ActionPerformed(evt);
            }
        });
        jMenu3.add(jMenuItem15);

        jMenuBar1.add(jMenu3);

        setJMenuBar(jMenuBar1);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    /**
     * Action - Menu -> Load
     * @param evt 
     */
    private void jMenuItem1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem1ActionPerformed
        LoadImageFromFile();
    }//GEN-LAST:event_jMenuItem1ActionPerformed
    
    /**
     * Action - Edit -> Make Grayscale
     * @param evt 
     */
    private void jMenuItem4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem4ActionPerformed
        if (Window.canvas == null)
        {
            JOptionPane.showMessageDialog(this, "Nemáte vložený žádny obrázek", "Neexistující obrazek", JOptionPane.WARNING_MESSAGE);
            return;
        }
        
        if(gss != null) {
            gss.setVisible(true);
        }
        else {
            gss = new GrayScaleSelector(this);
            gss.setVisible(true);
        }
        if(gss.isOK()){
            double[] weights = gss.getValues();
            BufferedImage newImg = Tools.GrayScale(canvas.getOriginalSizeImage(),weights[0],weights[1],weights[2]);
            
            canvas.saveAsPrevious(canvas.getOriginalSizeImage());
            canvas.setOriginalSizeImage(newImg);
            if(canvas.getZoomValue()!=1)
            {
                newImg = Tools.BilinearResize(newImg, canvas.getZoomValue());
            }
            canvas.setImage(newImg);
            
            this.repaint();
            this.saved = 0;
        }
    }//GEN-LAST:event_jMenuItem4ActionPerformed
    
    /**
     * Action - File -> Save
     * @param evt 
     */
    private void jMenuItem2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem2ActionPerformed
        save();
    }//GEN-LAST:event_jMenuItem2ActionPerformed
    
    /**
     * Private auxiliary method for saving
     */
    private void save()
    {
        if (Window.canvas == null)
        {
            JOptionPane.showMessageDialog(this, "Nemáte vložený žádny obrázek", "Neexistující obrazek", JOptionPane.WARNING_MESSAGE);
            return;
        }
        if (jFileChooser1.showSaveDialog(jMenu1)==JFileChooser.APPROVE_OPTION)
        {
            File f = jFileChooser1.getSelectedFile();
            try {
                ImageIO.write(canvas.getOriginalSizeImage(), "jpg", f);
            } catch (IOException ex) {
                //Prazdna obsluha
            }
            this.saved = 1;
        }
    }
    /**
     * Action - Edit -> Tresholding
     * @param evt 
     */
    private void jMenuItem8ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem8ActionPerformed
        if (canvas == null)
        {
            JOptionPane.showMessageDialog(this, "Nemáte vložený žádny obrázek", "Neexistující obrazek", JOptionPane.WARNING_MESSAGE);
            return;
        }
        
        if(ths != null) {
            ths.setVisible(true);
        }
        else {
            ths = new TresholdSelector(this);
            ths.setVisible(true);
        }
        if(ths.isOK()){
            
            int[] weights = ths.getValues();
            BufferedImage newImg = Dither.Tresholding(canvas.getOriginalSizeImage(),weights[0],weights[1],weights[2]);
            
            canvas.saveAsPrevious(canvas.getOriginalSizeImage());
            canvas.setOriginalSizeImage(newImg);
            if(canvas.getZoomValue()!=1)
            {
                newImg = Tools.BilinearResize(newImg, canvas.getZoomValue());
            }
            canvas.setImage(newImg);
          
            this.repaint();
            this.saved = 0;
        }
    }//GEN-LAST:event_jMenuItem8ActionPerformed
    
    /**
     * Action - File -> Exit
     * @param evt 
     */
    private void jMenuItem3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem3ActionPerformed
         if (Window.canvas == null || this.saved == 1) {
            if ((JOptionPane.showConfirmDialog(this, "Chcete ukončit program?","Warning",JOptionPane.YES_NO_OPTION))==JOptionPane.YES_OPTION)
                System.exit(0);
            else
                return;
        }
        
        int exit;
        if((exit = JOptionPane.showConfirmDialog(this, "Chcete obrazek ulozit?","Warning",JOptionPane.YES_NO_CANCEL_OPTION))==JOptionPane.YES_OPTION)
        {
            save();
            System.exit(0);
        }
        if (exit == JOptionPane.CANCEL_OPTION){
            //do nothing
        }
        else System.exit(0);   
    }//GEN-LAST:event_jMenuItem3ActionPerformed

    /**
     * Display the about frame
     * @param evt 
     */
    private void jMenuItem15ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem15ActionPerformed
        JOptionPane.showMessageDialog(this, "Tento program byl vytvořen pro účel zápočtu z POGR1\n(C) Karel Šimánek, FJFI Praha","O Programu",JOptionPane.INFORMATION_MESSAGE);
    }//GEN-LAST:event_jMenuItem15ActionPerformed

    /**
     * Window Closing event
     * @param evt 
     */
    private void formWindowClosing(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowClosing
       
        if (Window.canvas == null || this.saved == 1) {
            if ((JOptionPane.showConfirmDialog(this, "Chcete ukončit program?","Warning",JOptionPane.YES_NO_OPTION))==JOptionPane.YES_OPTION)
                System.exit(0);
            else
                return;
        }
        
        int exit;
        if((exit = JOptionPane.showConfirmDialog(this, "Chcete obrazek ulozit?","Warning",JOptionPane.YES_NO_CANCEL_OPTION))==JOptionPane.YES_OPTION)
        {
            save();
            System.exit(0);
        }
        if (exit == JOptionPane.CANCEL_OPTION){
            //do nothing
        }
        else System.exit(0);        
    }//GEN-LAST:event_formWindowClosing

    /**
     * Action Edit -> Dithering
     * @param evt 
     */
    private void jMenuItem16ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem16ActionPerformed
        if (Window.canvas == null)
        {
            JOptionPane.showMessageDialog(this, "Nemáte vložený žádny obrázek", "Neexistující obrazek", JOptionPane.WARNING_MESSAGE);
            return;
        }
        
        if(ds != null) {
            ds.setVisible(true);
        }
        else {
            ds = new DitherSelector(this);
            ds.setVisible(true);
        }
        if(ds.isOK()){
        String method = ds.getValues();
        
        // 
        BufferedImage newImg = null;
        if (method.equals("Floyd-Steinberg")) {
            newImg = Dither.FloydSteinberg(canvas.getOriginalSizeImage());
        }
        if (method.equals("Atkinson")) {
            newImg = Dither.Atkinson(canvas.getOriginalSizeImage());
        }
        if (method.equals("Jarvice-Judice-Ninke")) {
            newImg = Dither.JarvisJudiceNinke(canvas.getOriginalSizeImage());
        }
        if (method.equals("Stucki")) {
            newImg = Dither.Stucki(canvas.getOriginalSizeImage());
        }
        if (method.equals("Bayer 2x2")) {
            newImg = Dither.Bayer_2x2(canvas.getOriginalSizeImage());
        }
        if (method.equals("Bayer 4x4")) {
            newImg = Dither.Bayer_4x4(canvas.getOriginalSizeImage());
        }
        if (method.equals("Bayer 8x8")) {
            newImg = Dither.Bayer_8x8(canvas.getOriginalSizeImage());
        }
        if (method.equals("Clustered 4x4")) {
            newImg = Dither.Clustered_4x4(canvas.getOriginalSizeImage());
        }
        if (method.equals("Random")) {
            newImg = Dither.Random(canvas.getOriginalSizeImage());
        }
        
        canvas.saveAsPrevious(canvas.getOriginalSizeImage());
        canvas.setOriginalSizeImage(newImg);
        if(canvas.getZoomValue()!=1)
        {
            newImg = Tools.BilinearResize(newImg, canvas.getZoomValue());
        }
        canvas.setImage(newImg);
            
        this.repaint();
        this.saved = 0;
        }
    }//GEN-LAST:event_jMenuItem16ActionPerformed
    
    /**
     * Action Toolbar -> rotateRight
     * @param evt 
     */
    private void jButton4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton4ActionPerformed
        if(Window.canvas == null) {
            return;
        }
        canvas.setImage(Tools.rotateRight(canvas.getImage()));
        repaint();
        this.saved = 0;
    }//GEN-LAST:event_jButton4ActionPerformed

    /**
     * Action Toolbar -> rotateLeft
     * @param evt 
     */
    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        if(Window.canvas == null) {
            return;
        }
        canvas.setImage(Tools.rotateLeft(canvas.getImage()));
        repaint();
        this.saved = 0;
    }//GEN-LAST:event_jButton1ActionPerformed
    
    /**
     * Action Edit -> Asciify
     * @param evt 
     */
    private void jMenuItem5ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem5ActionPerformed
        if (Window.canvas == null)
        {
            JOptionPane.showMessageDialog(this, "Nemáte vložený žádny obrázek", "Neexistující obrazek", JOptionPane.WARNING_MESSAGE);
            return;
        }
        
        if(afs != null) {
            afs.setVisible(true);
        }
        else {
            afs = new AsciiFontSelector(this);
            afs.setVisible(true);
        }
        if(afs.isOK()){
            Ascii ascii = new Ascii();
            Font f = new Font("Monospaced",Font.BOLD,afs.getValues());
            BufferedImage newImg = ascii.Asciify(canvas.getOriginalSizeImage(), f);
            
            canvas.saveAsPrevious(canvas.getOriginalSizeImage());
            canvas.setOriginalSizeImage(newImg);
            if(canvas.getZoomValue()!=1)
            {
                newImg = Tools.BilinearResize(newImg, canvas.getZoomValue());
            }
            canvas.setImage(newImg);
                        
            repaint();
            this.saved = 0;
        }
    }//GEN-LAST:event_jMenuItem5ActionPerformed

    /**
     * Action Toolbar -> Save button
     * @param evt 
     */
    private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
        if(Window.canvas == null) {
            return;
        }
        
        if (this.saved == 0) {
            save();
        }
    }//GEN-LAST:event_jButton2ActionPerformed

    /**
     * Action Toolbar -> Zoom In
     * @param evt 
     */
    private void jButton3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton3ActionPerformed
         if(Window.canvas == null) {
            return;
        }   
        
        if ((double)(canvas.getZoomValue()+0.1)==1) {
            canvas.setOriginalSizeImage(canvas.getImage());
        }
        canvas.setImage(Tools.BilinearResize(canvas.getOriginalSizeImage(),(double)(canvas.getZoomValue()+0.1)));
        repaint();
    }//GEN-LAST:event_jButton3ActionPerformed

    /**
     * Action Toolbar -> Zoom Out
     * @param evt 
     */
    private void jButton5ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton5ActionPerformed
              if(Window.canvas == null) {
            return;
        }   
        
        if (canvas.getZoomValue()-0.1==1) {
            canvas.setOriginalSizeImage(canvas.getImage());
        }
       if(canvas.getZoomValue()<=0.2) {
            canvas.setImage(Tools.BilinearResize(canvas.getOriginalSizeImage(), (double)canvas.getZoomValue()/2));
        }
       else {
            canvas.setImage(Tools.BilinearResize(canvas.getOriginalSizeImage(), (double)(canvas.getZoomValue()-0.1)));
        }
       repaint();
    }//GEN-LAST:event_jButton5ActionPerformed

    /**
     * Action Edit -> Highlight edges
     * @param evt 
     */
    private void jMenuItem6ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem6ActionPerformed
        if (Window.canvas == null)
        {
            JOptionPane.showMessageDialog(this, "Nemáte vložený žádny obrázek", "Neexistující obrazek", JOptionPane.WARNING_MESSAGE);
            return;
        }
        
        if(hes != null) {
            hes.setVisible(true);
        }
        else {
            hes = new HighlightEdgesSelector(this);
            hes.setVisible(true);
        }
        if(hes.isOK()){
        
        BufferedImage newImg = Tools.HighlightEdges(canvas.getOriginalSizeImage(),hes.getValues());
         
            canvas.saveAsPrevious(canvas.getOriginalSizeImage());
            canvas.setOriginalSizeImage(newImg);
            if(canvas.getZoomValue()!=1)
            {
                newImg = Tools.BilinearResize(newImg, canvas.getZoomValue());
            }
            canvas.setImage(newImg);
            
            this.repaint();
            this.saved = 0;
        }
    }//GEN-LAST:event_jMenuItem6ActionPerformed
    
    /**
     * Action Toolbar -> Previous button
     * @param evt 
     */
    private void jButton6ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton6ActionPerformed
        
        BufferedImage previous;
        
        if(Window.canvas == null) {
            return;
        }        
        
        if ((previous = canvas.getPrevious()) != null)
        {
            canvas.setOriginalSizeImage(previous);
            canvas.setImage(Tools.BilinearResize(previous, canvas.getZoomValue()));
            this.saved = 0;
            repaint();
        }
    }//GEN-LAST:event_jButton6ActionPerformed

    /**
     * Action Toolbar -> Next button
     * @param evt 
     */
    private void jButton8ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton8ActionPerformed
        
        BufferedImage next;
        
        if(Window.canvas == null) {
            return;
        }        
        
        if ((next = canvas.getNext()) != null)
        {
            canvas.setOriginalSizeImage(next);
            canvas.setImage(Tools.BilinearResize(next, canvas.getZoomValue()));
            this.saved = 0;
            repaint();
        }
    }//GEN-LAST:event_jButton8ActionPerformed

    /**
     * Action Toolbar -> Load button
     * @param evt 
     */
    private void jButton7ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton7ActionPerformed
        LoadImageFromFile();
    }//GEN-LAST:event_jButton7ActionPerformed

    /**
     * Method for loading images from file
     */
    private void LoadImageFromFile()
    {
       if(jFileChooser1.showOpenDialog(jMenu1) == JFileChooser.APPROVE_OPTION) 
       {
            if(scrollFrame == null){
                canvas = new MyCanvas();
                scrollFrame = new JScrollPane(canvas);
                this.add(scrollFrame,BorderLayout.CENTER);
            }
            
            File f = jFileChooser1.getSelectedFile();
            try {
                BufferedImage img = ImageIO.read(f);
                canvas.setImage(img);
                canvas.setZoomValue(1);
                canvas.setOriginalSizeImage(img);
            } catch (IOException ex) {
                //Prazdna obsluha
            }
            
            canvas.setPreferredSize(new Dimension(canvas.getImage().getWidth(),canvas.getImage().getHeight()));  
            canvas.repaint();
            
            canvas.emptyRedoStack();
            canvas.emptyUndoStack();
            
            this.revalidate();
            this.repaint();
            this.saved = 1;
        }
    }
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException | InstantiationException | IllegalAccessException | javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(Window.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            @Override
            public void run() {
                new Window().setVisible(true);
            }
        });
    }
    /**
     * variable represents the save state of the image
     */
    private int saved = 0;
    /**
     * scrollFrame
     */
    private JScrollPane scrollFrame;
    /**
     * GrayScale selector
     */
    private GrayScaleSelector gss;
    /**
     * Treshold selector
     */
    private TresholdSelector ths;
    /*
     * Highlight Edges selector
     */
    private HighlightEdgesSelector hes;
    /*
     * Dithering selector
     */
    private DitherSelector ds;
    /**
     * Ascii font size selector
     */
    private AsciiFontSelector afs;
    /**
     * Canvas
     */
    public static MyCanvas canvas;
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private javax.swing.JButton jButton3;
    private javax.swing.JButton jButton4;
    private javax.swing.JButton jButton5;
    private javax.swing.JButton jButton6;
    private javax.swing.JButton jButton7;
    private javax.swing.JButton jButton8;
    private javax.swing.JFileChooser jFileChooser1;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JMenu jMenu1;
    private javax.swing.JMenu jMenu2;
    private javax.swing.JMenu jMenu3;
    private javax.swing.JMenuBar jMenuBar1;
    private javax.swing.JMenuItem jMenuItem1;
    private javax.swing.JMenuItem jMenuItem15;
    private javax.swing.JMenuItem jMenuItem16;
    private javax.swing.JMenuItem jMenuItem2;
    private javax.swing.JMenuItem jMenuItem3;
    private javax.swing.JMenuItem jMenuItem4;
    private javax.swing.JMenuItem jMenuItem5;
    private javax.swing.JMenuItem jMenuItem6;
    private javax.swing.JMenuItem jMenuItem8;
    private javax.swing.JPopupMenu.Separator jSeparator1;
    private javax.swing.JToolBar jToolBar1;
    // End of variables declaration//GEN-END:variables
}
